package at.ac.uibk.gitsearch.web.rest;

import java.util.List;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import at.ac.uibk.gitsearch.service.dto.OAuth2ConfigDTO;
import at.ac.uibk.gitsearch.service.oauth2.OAuth2ConfigService;

/**
 * Controller to authenticate users.
 */
@RestController
@RequestMapping("/oauth2Config")
public class OAuth2ConfigResource {

	private OAuth2ConfigService oAuth2ConfigService;

    public OAuth2ConfigResource(OAuth2ConfigService oAuth2ConfigService) {
    	this.oAuth2ConfigService = oAuth2ConfigService;
    }

    @GetMapping("/config/{configId}")
    public ResponseEntity<OAuth2ConfigDTO> getOAuth2Config(@PathVariable(value = "configId") String configId) {

    	return new ResponseEntity<>(oAuth2ConfigService.findByRegistrationId(configId), HttpStatus.OK);
    }
    
    @GetMapping("/allConfigs")
    public ResponseEntity<List<OAuth2ConfigDTO>> getOAuth2Configs() {
    	return new ResponseEntity<>(oAuth2ConfigService.getPublicRegistrations(), HttpStatus.OK);
    }

}
